Sound.init()
local click = Sound.openWav("app0:/click.wav")
local shutter = Sound.openWav("app0:/shutter.wav")
local white = Color.new(255,255,255)
local black = Color.new(0,0,0)
local imginterface = Graphics.loadImage("app0:/interface.png")
local imggrid = Graphics.loadImage("app0:/grid.png")
local sliderFront = Graphics.loadImage("app0:/slider1.png")
local sliderBack = Graphics.loadImage("app0:/slider2.png")
local imgframe = Graphics.loadImage("app0:/frames/tmp.png")

System.createDirectory("ux0:/data/CAMERAPRO")

oldpad = SCE_CTRL_CROSS

-- Initializing outer camera at 640x480@45fps 
Camera.init(OUTER_CAM, VGA_RES, 45)
Camera.setSharpness(400)

grid = false
capturing = false
capturedelay = 0.0
delayTouch = 0.0
sliderX = 190
showBrightness = false
brightness = 470
showContrast = false
contrast = 470
filter = 0
drawfilter = false
whitebalance = 0
drawwhitebalance = false
innerCam = false
nightmode = false
halfSize = false
frame = 0

function OneshotPrint(my_func)
	my_func()
	Screen.flip()
	my_func()
	Screen.flip()
	my_func()
end

function Hideall()
	grid = false
	showBrightness = false
	showContrast = false
end

function FlipCamera()
	if innerCam==true then
		Camera.term()
		Camera.init(INNER_CAM, VGA_RES, 45)
	else
		Camera.term()
		Camera.init(OUTER_CAM, VGA_RES, 45)
	end
end

function SetFilter()
	if filter == 0 then
		Camera.setEffect(EFFECT_NONE)
	elseif filter == 1 then
		Camera.setEffect(EFFECT_NEGATIVE)
	elseif filter == 2 then
		Camera.setEffect(EFFECT_BLACKWHITE)
	elseif filter == 3 then
		Camera.setEffect(EFFECT_SEPIA)
	elseif filter == 4 then
		Camera.setEffect(EFFECT_BLUE)
	elseif filter == 5 then
		Camera.setEffect(EFFECT_RED)
	elseif filter == 6 then
		Camera.setEffect(EFFECT_GREEN)
	end
end

function Setwhitebalance()
	if whitebalance == 0 then
		Camera.setWhiteBalance(WB_AUTO)
	elseif whitebalance == 1 then
		Camera.setWhiteBalance(WB_DAYLIGHT)
	elseif whitebalance == 2 then
		Camera.setWhiteBalance(WB_CWF)
	elseif whitebalance == 3 then
		Camera.setWhiteBalance(WB_SLSA)
	end
end

function SetNightmode()
	if nightmode == false then
		Camera.setNightmode(NIGHTMODE_OFF)
	else
		Camera.setNightmode(NIGHTMODE_MED)
	end
end

function SetFrame()
	if frame == 0 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/tmp.png")
	elseif frame == 1 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame01.png")
	elseif frame == 2 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame02.png")
	elseif frame == 3 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame03.png")
	elseif frame == 4 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame04.png")
	elseif frame == 5 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame05.png")
	elseif frame == 6 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame06.png")
	elseif frame == 7 then
		Graphics.freeImage(imgframe)
		imgframe = Graphics.loadImage("app0:/frames/frame07.png")
	end
end

-- Main loop
while true do
	
	local x1,y1 = Controls.readTouch()
	
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	else
	-- check for touch
		if x1 ~= nil then
		
			-- Slider Set
			if x1<768 and x1>213 and y1>440 then
				sliderX = x1
				if showBrightness == true then
					Camera.setBrightness(math.floor(sliderX/3)-63)
					brightness=sliderX
				end
				if showContrast == true then
					Camera.setContrast(math.floor(sliderX/3)-63)
					contrast=sliderX
				end
			end
		
			-- grid
			if x1<90 and y1<90 then
				delayTouch = 3
				Sound.play(click, NO_LOOP)
				if grid == true then
					grid = false
				else
					OneshotPrint(Hideall)
					grid = true
				end
			-- brightness
			elseif x1<90 and y1>120 and y1<200 then
				delayTouch = 3
				Sound.play(click, NO_LOOP)
				if showBrightness == true then
					showBrightness = false
				else
					OneshotPrint(Hideall)
					sliderX = brightness
					showBrightness = true
				end
			-- contrast
			elseif x1<90 and y1>230 and y1<310 then
				delayTouch = 3
				Sound.play(click, NO_LOOP)
				if showContrast == true then
					showContrast = false
				else
					OneshotPrint(Hideall)
					sliderX = contrast
					showContrast = true
				end
			-- filters
			elseif x1>860 and y1>440 then
				delayTouch = 3
				Sound.play(click, NO_LOOP)
				if filter < 6 then
					filter = filter + 1
				else
					filter = 0
				end
				OneshotPrint(SetFilter)
				drawfilter = true
			-- whitebalance
			elseif x1<90 and y1>330 and y1<420 then
				delayTouch = 3
				Sound.play(click, NO_LOOP)
				if whitebalance < 3 then
					whitebalance = whitebalance + 1
				else
					whitebalance = 0
				end
				OneshotPrint(Setwhitebalance)
				drawwhitebalance = true
			-- Flip Camera
			elseif x1>860 and y1<90 then
				delayTouch = 5
				Sound.play(click, NO_LOOP)
				if innerCam == false then
					innerCam = true
				else
					innerCam = false
				end
				OneshotPrint(FlipCamera)
			-- Night Mode
			elseif x1>860 and y1>120 and y1<200 then
				delayTouch = 2
				Sound.play(click, NO_LOOP)
				if nightmode == false then
					nightmode = true
				else
					nightmode = false
				end
				OneshotPrint(SetNightmode)
			-- Frames
			elseif x1>860 and y1>330 and y1<420 then
				delayTouch = 2
				Sound.play(click, NO_LOOP)
				if frame < 7 then
					frame = frame + 1
				else
					frame = 0
				end
				OneshotPrint(SetFrame)
			-- Ratio
			elseif x1<90 and y1>450 then
				delayTouch = 2
				Sound.play(click, NO_LOOP)
				if halfSize == false then
					halfSize = true
				else
					halfSize = false
				end
			-- GALLERY
			elseif x1>760 and x1<850 and y1<90 then
				delayTouch = 3
				Sound.play(click, NO_LOOP)
				dofile("app0:/gallery.lua")
			-- CAPTURE
			elseif x1>860 and y1>215 and y1<330 then
				delayTouch = 3
				if capturing == false then
					capturedelay=0
					Sound.play(shutter, NO_LOOP)
					capturing=true
				end
				
			end
		end
	end
	
	-- Limit slider values
	if sliderX<190 then
		sliderX = 190
	end
	if sliderX>740 then
		sliderX = 740
	end 

	-- Getting current camera output
	scene = Camera.getOutput()
	
	-- Blend camera scene
	Graphics.initBlend()
	Screen.clear()
	Graphics.setImageFilters(scene, FILTER_LINEAR, FILTER_LINEAR)
	
	if halfSize == true then
		Graphics.drawScaleImage(117, 0, scene, 1.135, 1.135)
	else
		Graphics.drawScaleImage(0, -90, scene, 1.5, 1.5)
	end

	if frame> 0 then 
		Graphics.drawImage(0, 0, imgframe)
	end
	
	
	if capturing == false then
		if grid == true then
			Graphics.drawImage(0, 0, imggrid)
		end
		Graphics.drawImage(0, 0, imginterface)
		
		if showBrightness == true then
			Graphics.drawImage(214, 480, sliderBack)
			Graphics.drawImage(sliderX, 463, sliderFront)
			Graphics.debugPrint(425, 512, "Brightness",white)
		end
		
		if showContrast == true then
			Graphics.drawImage(214, 480, sliderBack)
			Graphics.drawImage(sliderX, 463, sliderFront)
			Graphics.debugPrint(430, 512, "Contrast",white)
		end
		
		if drawfilter == true then
			if delayTouch>0.1 then
				if filter == 0 then
					Graphics.debugPrint(805, 516, "Filter: OFF", white)					
				elseif filter == 1 then
					Graphics.debugPrint(785, 516, "Filter: NEGATIVE", black)					
				elseif filter == 2 then
					Graphics.debugPrint(805, 516, "Filter: B&W", white)					
				elseif filter == 3 then
					Graphics.debugPrint(805, 516, "Filter: SEPIA", white)					
				elseif filter == 4 then
					Graphics.debugPrint(805, 516, "Filter: BLUE", white)					
				elseif filter == 5 then
					Graphics.debugPrint(805, 516, "Filter: RED", white)					
				elseif filter == 6 then
					Graphics.debugPrint(805, 516, "Filter: GREEN", white)					
				end
			else
			drawfilter=false
			end
		end		
		
		if drawwhitebalance == true then
			if delayTouch>0.1 then
				if whitebalance == 0 then 
				Graphics.debugPrint(15, 410, "WB: Automatic" ,white)
				elseif whitebalance == 1 then 
				Graphics.debugPrint(15, 410, "WB: Daylight" ,white)
				elseif whitebalance == 2 then 
				Graphics.debugPrint(15, 410, "WB: Cool White" ,white)
				elseif whitebalance == 3 then 
				Graphics.debugPrint(15, 410, "WB: Standard Light" ,white)
				end
			else
			drawwhitebalance=false
			end
		end
		
	else
	capturedelay = capturedelay + 0.1
		if capturedelay>1 then
		day_num, d, mn, y = System.getDate()
		h,m,s = System.getTime()
		System.takeScreenshot("ux0:/data/CAMERAPRO/IMG_".. d .. mn .. y .. h .. m .. s ..".jpg", true)
		capturing=false
		capturedelay=0
		end
	end

	Graphics.termBlend()
	
	-- Check for input
	pad = Controls.read()
	if Controls.check(Controls.read(), SCE_CTRL_TRIANGLE) then
		delayTouch=3
		Sound.play(click, NO_LOOP)
		dofile("app0:/gallery.lua")
	end
	
	-- Grid with up/down
	if Controls.check(Controls.read(), SCE_CTRL_UP) then
		grid = true
	elseif Controls.check(Controls.read(), SCE_CTRL_DOWN) then
		grid = false
	end

	if Controls.check(Controls.read(), SCE_CTRL_RIGHT) then
		delayTouch = 2
		Sound.play(click, NO_LOOP)
		if frame < 7 then
			frame = frame + 1
		else
			frame = 0
		end
		OneshotPrint(SetFrame)
	elseif Controls.check(Controls.read(), SCE_CTRL_LEFT) then
		delayTouch = 2
		Sound.play(click, NO_LOOP)
		if frame > 0 then
			frame = frame - 1
		else
			frame = 7
		end
		OneshotPrint(SetFrame)
	end
	
	-- Capture with R
	if Controls.check(pad, SCE_CTRL_RTRIGGER) and not Controls.check(oldpad, SCE_CTRL_RTRIGGER) then
		if delayTouch<0.1 then
			delayTouch=3
			Sound.play(shutter, NO_LOOP)
			if capturing == false then
				capturedelay=0
				capturing=true
			end
		end
	end
	
	-- Flip screen
	Screen.flip()
	oldpad = pad
end